/*
La classe 
RICEVE dal Gestore i prezzi da visualizzare via server
1. Crea la finestra di scelta
2. Passa la selezione eil controllo a MessageWindow

*/

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;


//N.B alcuni dei package di swing potrebbero avere un path diverso in un sistema non Mac
//probabilmente il javax va sostituito con com.sun.java.[    ].*

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;

public class Finestra1 extends JFrame{
   public static int WIDTH=700;
   public static int HEIGHT=500;
   public static String TITLE="Scelta tipo abbonamento";
    
   // Componenti GUI della finestra
   
  MessageWindow dialog;
  SetupWindow setupwin;
  
 
  
   
   JPanel buttonchoicePanel=new JPanel();
   ButtonGroup abbonamento=new ButtonGroup();
   JPanel pannelloImmagine=new JPanel();
   JPanel pannelloabbonamento=new JPanel();
   
   JMenuBar barramenu=new JMenuBar();  
   JMenu menu=new JMenu("Menu");
   JMenuItem setup=new JMenuItem("Setup");
   JMenuItem quit=new JMenuItem("Quit");
      
   JButton cancelbutton=new JButton ("Esci");
   JButton selectbutton=new JButton("Seleziona");
   
   String [] settori={"A:  Curva   ","B:  Tribuna centrale  ","C:  Distinti centrali  ","D:  Tribuna laterale  ","E:  Tribuna laterale  ","F:  Distinti laterali  ","G:  Distinti Laterali ","H:  Curva ospiti  "};
   JRadioButton [] radiobutton=new JRadioButton[settori.length];
   
   Icon stadio=new ImageIcon("stadio.gif");
   Icon [] iconastadio={stadio};
   JList icona=new JList(iconastadio);
   
  
 // Costruttore
   public Finestra1(String [] prezzi,Gestore gestore,int op) {
   
   super(TITLE);
   addWindowListener(new WindowHandler());
   buildGUI(prezzi,gestore,op);  
   setSize(WIDTH,HEIGHT);  
   getContentPane().add("South",buttonchoicePanel);
   getContentPane().add("Center",pannelloabbonamento);
   getContentPane().add("North",pannelloImmagine);
   setBackground(Color.red);
   show();
   
      } 
   
   // Creazione dei pulsanti degli abbonamenti
    void buildGUI(String [] prezzi,Gestore gestore,int op) {   
    
     Font font12= new Font("Palatino",Font.BOLD,12);
     for (int i=0;i<settori.length;i++) {
   	radiobutton[i]=new JRadioButton(settori[i]+" "+prezzi[i]);
   	abbonamento.add(radiobutton[i]);
   	pannelloabbonamento.add(radiobutton[i]);
   	radiobutton[i].addActionListener(new ButtonHandler(gestore));
   	radiobutton[i].setBackground(Color.black);
 	radiobutton[i].setForeground(Color.white);
 	radiobutton[i].setFont(font12);
   	}
   	pannelloabbonamento.setLayout(new GridLayout(4,2));
   	pannelloabbonamento.setBackground(Color.black);
        pannelloabbonamento.setForeground(Color.white);
    // Completamento della componente grafica	
   	setupButtonChoice(gestore);
        if(op==1) setupMenu();
        setupImage();
        setupFont(op);
        
   }
   
   // Creazione pulsanti di scelta (colore e gestori)   
   void setupButtonChoice(Gestore gestore) {

   cancelbutton.setBackground(Color.black);
   selectbutton.setBackground(Color.black);
   cancelbutton.setForeground(Color.yellow);
   selectbutton.setForeground(Color.yellow);
   buttonchoicePanel.setBackground(Color.red);
   buttonchoicePanel.add(cancelbutton);
   buttonchoicePanel.add(selectbutton);
   cancelbutton.addActionListener(new ButtonHandler(gestore));
   selectbutton.addActionListener(new ButtonHandler(gestore));
   
}

//Aggancio e settaggio menu (colore e gestori)
 void setupMenu() {
 
 barramenu.setBackground(Color.black);
 menu.setBackground(Color.black);
 menu.setForeground(Color.white);
 setup.setBackground(Color.black);
 setup.setForeground(Color.yellow);
 quit.setBackground(Color.black);
 quit.setForeground(Color.yellow);menu.add(setup);
 menu.add(new JSeparator());
 menu.add(quit);
 setup.addActionListener(new MenuHandler());
 quit.addActionListener(new MenuHandler());
 barramenu.add(menu);
 setJMenuBar(barramenu);
 
}
 
//Definizione immagine stadio
void setupImage() {

 icona.setFixedCellHeight(300);
 icona.setFixedCellWidth(540);
 pannelloImmagine.add(icona); 
 pannelloImmagine.setBackground(Color.white);

} 

void setupFont(int op) {

   Font font10=new Font("Palatino",Font.BOLD,10);
   Font font14=new Font("Palatino",Font.BOLD,14);
   Font font12=new Font("Palatino",Font.BOLD,12);
   selectbutton.setFont(font14);
   cancelbutton.setFont(font14);
   if(op==1){
       setup.setFont(font10);
      quit.setFont(font10);
      menu.setFont(font12);
   }
 }
   
 
     
   //Classe che gestisce i bottoni
 public class ButtonHandler implements ActionListener {
     Gestore gestore;
  
   ButtonHandler(Gestore mioGest){
       gestore=mioGest;
       }
       
     public void actionPerformed(ActionEvent e) {
      String etichetta=e.getActionCommand();
      String selezione="";
      if (etichetta.equals("Esci"))   System.exit(0);
     //Ricerca etichetta selezionata   
      boolean trovato=false;       
      if(etichetta.equals("Seleziona")) {
      	  for(int i=0;i<8;i++){
             if(radiobutton[i].isSelected()){
      	        trovato=true;
      	        selezione=radiobutton[i].getText();
      	        }
          }
          if (selezione.equals("")) {
                  selezione="Nessuna selezione";
                  }
          if(trovato) {        
             int lung=selezione.length();
             int n=selezione.indexOf("");
             String costo=selezione.substring(n);
             char sett=selezione.charAt(0);
             String settore=sett+"";
             String tipo=selezione.substring(4,n-1);   
             String testo[]={"HAI SELEZIONATO",tipo,"SETTORE: "+settore,"COSTO: "+costo};
             String bottoni[]={"CONFERMA","CANCELLA"};
      //Chiamata alla finestra di dialogo
             dialog=new MessageWindow(Finestra1.this,"Conferma la tua selezione",testo,true,bottoni,gestore);
             dialog.setLocation(200,200);
             dialog.show();
             }
          else {
                  String testo []={"    NESSUNA SELEZIONE","     ","   E' necessaria una selezione  ","     per poter proseguire  "};
                  String bottoni []={"CANCELLA"};
                  dialog=new MessageWindow(Finestra1.this,"ATTENZIONE",testo,true,bottoni,gestore);
                  dialog.setLocation(200,200);
                  dialog.show();
                  }
       }
     }
   }// Fine ButtonHandler
   
   
   //Classe che implementa i menu di sistema
    public class MenuHandler implements ActionListener{
       public void actionPerformed(ActionEvent e) {
          String s=e.getActionCommand();
          if(s.equals("Quit")) System.exit(0);	      
          if(s.equals("Setup")) setupwin= new SetupWindow();
             
         }
     }             
    
   
  }// Fine Finestra1
  
  
   // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
   public void windowClosing(WindowEvent e) {
      System.exit(0);
     }
   }